﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using System.Windows.Media.Imaging;
using BlitWriteableBitmapSample;
using System.IO;

namespace ParticleWP7
{
    public partial class MainPage : PhoneApplicationPage
    {
        /* a Windows Phone port of the Silverlight example by Bill Reiss:
         * http://blogs.silverarcade.com/silverlight-games-101/15/silverlight-blitting-and-blending-with-silverlights-writeablebitmap/
         */
        
        #region Fields
        WriteableBitmap bmp;
        WriteableBitmap particleBmp;
        Rect particleSourceRect;
        ParticleEmitter emitter = new ParticleEmitter();
        DateTime lastUpdate = DateTime.Now;
        #endregion

        #region Constructor
        public MainPage()
        {
            InitializeComponent();

            this.ContentPanel.Loaded += new RoutedEventHandler(ContentPanel_Loaded);
        }

        private void ContentPanel_Loaded(object sender, RoutedEventArgs e)
        {
            int width = (int)this.ContentPanel.ActualWidth;
            int height = (int)this.ContentPanel.ActualHeight;

            particleBmp = LoadBitmap("/ParticleWP7;component/FlowerBurst.jpg");
            particleSourceRect = new Rect(0, 0, 64, 64);
            bmp = new WriteableBitmap(width, height);
            bmp.Clear(Colors.Black);
            image.Source = bmp;
            emitter = new ParticleEmitter();
            emitter.Center = new Point(width / 2, height / 2);
            emitter.TargetBitmap = bmp;
            emitter.ParticleBitmap = particleBmp;
            CompositionTarget.Rendering += new EventHandler(CompositionTarget_Rendering);
            this.MouseMove += new MouseEventHandler(MainPage_MouseMove);
        }
        #endregion

        #region Private methods
        private WriteableBitmap LoadBitmap(string path)
        {
            BitmapImage img = new BitmapImage();
            img.CreateOptions = BitmapCreateOptions.None;
            Stream s = Application.GetResourceStream(new Uri(path, UriKind.Relative)).Stream;
            img.SetSource(s);
            return new WriteableBitmap(img);
        }

        private void MainPage_MouseMove(object sender, MouseEventArgs e)
        {
            emitter.Center = e.GetPosition(image);
        }

        private void CompositionTarget_Rendering(object sender, EventArgs e)
        {
            bmp.Clear(Colors.Black);

            double elapsed = (DateTime.Now - lastUpdate).TotalSeconds;
            lastUpdate = DateTime.Now;
            emitter.Update(elapsed);

            bmp.Invalidate();
        }
        #endregion
    }
}